package com.example.batterymanager_sample;

import android.app.Activity;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;

/**
 * 
 * 1) Analyser le code du manifest : le receiver n'est pas déclarer, pourquoi ?
 * 2) Rajouter le code qui permet de détecter que l'équipement est connecté à une
 * à une alimentation électrique externe, puis afficher le résultat dans le logcat
 * 
 * 
 * @author fcamps
 *
 */

public class MainActivity extends Activity {

	private static final String TAG = "BATTERY_MANAGER";

	private BroadcastReceiver mBatInfoReceiver = new BroadcastReceiver(){
		@Override
		public void onReceive(Context arg0, Intent intent) {
			
			Log.v(TAG, "INTENT = " + intent.getAction());
			
			if(intent.getAction().contains("BATTERY_CHANGED"))
			{
				int level = intent.getIntExtra("level", 0);
				Log.v(TAG, String.valueOf(level) + "%");
			}
		}
	};

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		this.registerReceiver(this.mBatInfoReceiver, 
				new IntentFilter(Intent.ACTION_BATTERY_CHANGED));
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}

	@Override
	protected void onDestroy()
	{
		super.onDestroy();
		Log.v(TAG, "onDestroy()");
		this.unregisterReceiver(this.mBatInfoReceiver);
		finish();
	}

}
