/*
 * Copyright (C) 2009 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
#include <string.h>
#include <jni.h>
#include "com_example_hellojni_HelloJni.h"

/* This is a trivial JNI example where we use a native method
 * to return a new VM String. See the corresponding Java source
 * file located at:
 *
 *   apps/samples/hello-jni/project/src/com/example/hellojni/HelloJni.java
 *
 *   http://docs.oracle.com/javase/1.5.0/docs/guide/jni/spec/functions.html
 */
JNIEXPORT jstring Java_com_example_hellojni_HelloJni_stringFromJNI( JNIEnv* env,
		jobject thiz )
{
	return (*env)->NewStringUTF(env, "Hello from JNI FC!");
}

/* Tous les objets passes en parametre sont de type jobject */
JNIEXPORT void JNICALL Java_com_example_hellojni_HelloJni_JNIMethod
(JNIEnv * env, jobject thiz, jobject test_JNI )
{
	jobject TestJNI = (*env)->NewGlobalRef(env, test_JNI);

/*
    int i = 2;
	while (i>1) {
	  i++;
	}

	int ya=0;
	ya++; */


	if(TestJNI == NULL)
	{
		return;
	}

	jclass test_JNI_Class = (*env)->GetObjectClass(env, TestJNI);

	jmethodID getX = (*env)->GetMethodID(env, test_JNI_Class, "GetX", "()I");
	jint x = (*env)->CallIntMethod(env, TestJNI, getX);


	jmethodID getY = (*env)->GetMethodID(env, test_JNI_Class, "GetY", "(I)I");
	jint y = (*env)->CallIntMethod(env, TestJNI, getY, 1);


	jmethodID printHello = (*env)->GetMethodID(env, test_JNI_Class, "PrintHello", "()V");
	(*env)->CallVoidMethod(env, TestJNI, printHello);

	(*env)->DeleteGlobalRef(env, TestJNI);
}
