package exemple.android;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;

/**
 * <h4>Programme avec un thread qui joue une musique</h4>
 * 
 * Ce programme montre le probleme de jouer un musique dans une activite et ensuite
 * de redemarrer la musique lorsqu'on revient sur resume().<br>
 *   
 * TODO : surcharger la methode onResume, pour le redemarrage de l'application
 * puis onDestroy, onStop afin de garantir l'arret du thread. Faire en sorte que la musique soit
 * jouee en boucle infinie.
 * 
 * @author fcamps
 */
public class PressAndPlay extends Activity
{

	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.thread);        

		Button startButton = (Button) findViewById(R.id.trigger);
		
		startButton.setOnClickListener(new View.OnClickListener() 
		{
			public void onClick(View view)
			{
				//standalone play_music() function call causes
				//main thread to hang.  Instead, create
				//separate thread for time-consuming task
				Thread initBkgdThread = new Thread(new Runnable()
				{
					public void run() 
					{                      
						play_music();
					}     
				});
				initBkgdThread.start();
			}
		});        
	}

	int[] notes = {R.raw.c5, R.raw.b4, R.raw.a4, R.raw.g4};
	int NOTE_DURATION = 500; //millisec
	MediaPlayer m_mediaPlayer;

	/**
	 * 
	 */
	private void play_music()
	{
		for(int ii=0; ii<12; ii++)
		{
			//check to ensure main activity not paused
			if(!paused)
			{
				if(m_mediaPlayer != null) {m_mediaPlayer.release();
				} 
				m_mediaPlayer = MediaPlayer.create(this, notes[ii%4]);
				m_mediaPlayer.start();
				try 
				{
					Thread.sleep(NOTE_DURATION);
				} catch (InterruptedException e) 
				{
					e.printStackTrace();
				}
			}
		}
	}

	boolean paused = false;
	
	@Override
	protected void onPause()
	{
		paused = true;
		super.onPause();
		Log.v("tag1","PAUSE");
	} 
	@Override
	protected void onResume()
	{
		super.onResume();
		paused = false;
		Log.v("tag2","RESUME");
	}    
}