package exemple.android;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

/**
 * <h4>Activite qui lance une autre activite avec un retour</h4>
 * 
 * StartScreen lance PlayGame avec des parametres et recoit en des infos en retour de l'activite PlayGame.
 * -->analyser le code. La surchage de onActivityResult() permet d'obtenir un code de retour. L'atcivity est lance
 * par startActivityForResult()<br>
 * 
 * TODO : Ajouter un champ de saisi "1Fst name" et l'envoyer à l'activite
 * playgame qui affiche le nom et ce champ dans playgame<br>
 * 
 * @author fcamps
 */
public class StartScreen extends Activity
{
    private static final int PLAY_GAME = 1010;
    private TextView tv; 

    private int counter = 42;
    private String dataTexte = "Activite 1 ";

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.start);
        
        tv = (TextView) findViewById(R.id.startscreen_text);

        //display initial values
        tv.setText(dataTexte + ":" + counter);

        //setup button listener
        Button startButton = (Button) findViewById(R.id.play_game);
        
        startButton.setOnClickListener(new View.OnClickListener()
        {
            public void onClick(View view) 
            {
                startGame();
            }
        });
    }

    // La surchage de cette méthode permet de récupérer le code retour de 
    // l'application et des données dans l'objet Intent
    @Override
    protected void onActivityResult(int requestCode,
            int resultCode, Intent data) 
    {
        if (requestCode == PLAY_GAME && resultCode == RESULT_OK)
        {
        	counter = data.getExtras().getInt("returnInt");
            dataTexte = data.getExtras().getString("returnStr");
            
            //show it has changed
            tv.setText(dataTexte + " : " + counter);
        }
        
        super.onActivityResult(requestCode, resultCode, data);
    }

    /**
     * 
     */
    private void startGame()
    {
        Intent launchGame = new Intent(this, PlayGame.class);

        //passing information to launched activity
        launchGame.putExtra("counter", counter);
        launchGame.putExtra("dataTexte", "Activite 2");

        startActivityForResult(launchGame, PLAY_GAME);
    }
}
