package exemple.android.callLocalisationService;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import exemple.android.R;

/**
 * <h4> Lancement d'une activite avec des actions par defaut</h4>
 * 
 *Ce programme montre comment lancer la geolocalisation avec un mode par defaut :Intent.ACTION_VIEW.<br>
 *
 * TOULOUSE :<br>
 * Latitude = 43.6063, Longitude = 1.4529<br>
 * Lat    = 43 degrees,   36.4 minutes   North<br>
 * Long = 1 degrees,   27.2 minutes   East<br>
 *
 * TODO: modifier les données pour affciher le lieu précis<br>
 * de la formation, utiliser http://www.coordonnees-gps.fr/ ou google maps.<br>
 */
public class LaunchDemo extends Activity 
{
	private EditText lat;
	private EditText lon;
	
	@Override
	public void onCreate(Bundle icicle)
	{
		super.onCreate(icicle);
		setContentView(R.layout.geo);
		
		Button btn=(Button)findViewById(R.id.map);
		lat=(EditText)findViewById(R.id.lat);
		lon=(EditText)findViewById(R.id.lon);
		
		btn.setOnClickListener(new View.OnClickListener()
		{
			public void onClick(View view)
			{
				String _lat=lat.getText().toString();
				String _lon=lon.getText().toString();
				Uri uri=Uri.parse("geo:"+_lat+","+_lon);
				
				startActivity(new Intent(Intent.ACTION_VIEW, uri));
			}
		});
	}
}