package exemple.android.phoneService;

import android.app.Service;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Binder;
import android.os.IBinder;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.util.Log;
import android.widget.Toast;

/**
 * 
 * @author fcamps
 *
 */
public class ServiceCall extends Service implements ServiceConnection
{
	private static final String TAG = "MyCallListner";
	private ServiceCall serviceBinder;
	private final IBinder binder = new MyBinder();


	@Override
	public void onServiceConnected(ComponentName name, IBinder service)
	{

		serviceBinder = ((ServiceCall.MyBinder)service).getService();

		Log.i(TAG, "Connexion du service");
	}

	@Override
	public void onServiceDisconnected(ComponentName name)
	{
		serviceBinder = null;
		Log.i(TAG, "Deconnexion du service");
	}

	@Override
	public IBinder onBind(Intent intent)
	{
		Log.d(TAG, "##########>>>>  Checked for permission: \nresult: " +
				checkCallingPermission("exemple.android.phoneService.permission.MY_FIRST_SERVICE"));

		return binder;
	}

	@Override
	public void onStart(Intent intent, int startId)
	{
		String txtToast = "** Service d’appels démarré **: "+startId;
		Toast toast = Toast.makeText(getApplicationContext(), txtToast, Toast.LENGTH_SHORT);
		toast.show();

		// Mise en place du listener pour les appels
		TelephonyManager tManager = (TelephonyManager)getSystemService(Context.TELEPHONY_SERVICE);

		ListenerPhoneState listenerAppels = new ListenerPhoneState();

		// Attachement du listener
		tManager.listen(listenerAppels, PhoneStateListener.LISTEN_CALL_STATE);
	}

	/**
	 * 
	 * @author fcamps
	 *
	 */
	public class MyBinder extends Binder
	{

		ServiceCall getService()
		{
			return ServiceCall.this;
		}
	}
}

