package android.provider.diary;


import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;

import com.android.data.MyDB;

import datastorage.gen.R;

/**
 * 
 * @author fcamps
 *
 * Activity qui permet de tester le package com.android.data
 * Saisie des infos agenda -> ecriture dans la base
 * Affichage du contenu de l'agenda 
 *
 */
public class Diary extends Activity 
{
	EditText titleET, contentET;
	Button submitBT;
	MyDB dba;
	
	private static final String TAG = "ActivityDiary";
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.diary);
		
		dba = new MyDB(this);

		dba.open();
		
		titleET = (EditText)findViewById(R.id.diarydescriptionText);
		contentET = (EditText)findViewById(R.id.diarycontentText);
		submitBT = (Button)findViewById(R.id.submitButton);

		submitBT.setOnClickListener(new OnClickListener() 
		{

			public void onClick(View v)
			{
				try 
				{
					saveittoDB();
				}
				catch (Exception e) 
				{
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
	}
	
	@Override
	protected void onRestart()
	{
		super.onRestart();

		titleET.setText("");
		contentET.setText("");
		
		Log.v(TAG, "onRestart()");
	}

	@Override
	protected void onResume() 
	{
		super.onResume();
		
		titleET.setText("");
		contentET.setText("");
		
		Log.v(TAG, "onResume()");
	}


	@Override
	protected void onPause() {
		super.onPause();
		Log.v(TAG, "onPause()");
	}

	@Override
	protected void onStop()
	{
		super.onStart();
		Log.v(TAG, "onStop()");
	}

	@Override
	protected void onDestroy()
	{
		super.onDestroy();
		Log.v(TAG, "onDestroy()");
		
		dba.close();
		finish();
	}
	

	/**
	 * 
	 */
	public void saveittoDB()
	{
		//save to DB
		dba.insertdiary(titleET.getText().toString(), contentET.getText().toString());
		
		
		titleET.setText("");
		contentET.setText("");
		
		Intent i = new Intent(Diary.this, DisplayDiaries.class);
		startActivity(i);
		
		//finish();
	}
}