package com.android.testProvider;



import android.app.Activity;
import android.content.ContentResolver;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.widget.TextView;


/**
 * 
 * @author fcamps
 * Utilisation du provider de DIARY
 */
public class DataStorageTester extends Activity 
{
	/** Called when the activity is first created. */
	TextView tv;
	
	public  static final  String AUTHORITY = "android.provider.diary";
	private static final String uriDiary = "content://" + AUTHORITY + "/diaries";
	public static final Uri CONTENT_URI = Uri.parse(uriDiary);
	
	public static final int COLONNE_TITLE_NAME = 1;
	public static final int COLONNE_CONTENT_NAME = 2;
	

	@Override
	public void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.provider_test);

		// get textfield from layout
		tv = (TextView) findViewById(R.id.output);

		//get a content Resolver instance
		ContentResolver crInstance = getContentResolver(); 

		// query
		Cursor c = crInstance.query(CONTENT_URI, null, null, null, null);

		startManagingCursor(c);
		StringBuilder sb = new StringBuilder();

		// insert data from database in textfield to print
		if(c.moveToFirst())
		{
			do
			{
				sb.append(c.getString(COLONNE_TITLE_NAME)).append("\n" 
						+ c.getString(COLONNE_CONTENT_NAME)).append("\n");
			}
			while(c.moveToNext());
		}
		tv.setText(sb.toString());
	}
}
