
/**
 * @author fcamps
 *
 */
package android.exemple.TD4_0;


import java.util.ArrayList;

import android.app.ListActivity;
import android.content.ContentResolver;
import android.database.Cursor;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

/**
 * @author fcamps
 *         <p/>
 *         Exemple d'utilisation du content provider CONTACT
 *         http://www.higherpass.com/android/tutorials/working-with-android-contacts/
 *         <p/>
 *         Telephone : http://developer.android.com/reference/android/provider/ContactsContract.Data.html
 */
public class MyContacts1 extends ListActivity {
    private static final String TAG = "ContentUserDemo";
    private ArrayList<String> list = new ArrayList();
    String phone = "";
    String contact = "";
    String emailAddress = "";
    String id;
    Cursor phones;

    /**
     * Called when the activity is first created.
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        String phone = "";
        String email = "";
        String name = "";

        ContentResolver cr = getContentResolver();

        Cursor cur = cr.query(ContactsContract.Contacts.CONTENT_URI, null, null, null, null);


        if (cur.getCount() > 0) {

            while (cur.moveToNext()) {
                id = cur.getString(cur.getColumnIndex(ContactsContract.Contacts._ID));
                name = cur.getString(cur.getColumnIndex(ContactsContract.Contacts.DISPLAY_NAME));

                //System.out.println("name = " + name);

                if (Integer.parseInt(cur.getString(cur.getColumnIndex(ContactsContract.Contacts.HAS_PHONE_NUMBER))) > 0) {
                    //Query phone here.
                    if (Integer.parseInt(cur.getString(
                            cur.getColumnIndex(ContactsContract.Contacts.HAS_PHONE_NUMBER))) > 0) {
                        Cursor pCur = cr.query(
                                ContactsContract.CommonDataKinds.Phone.CONTENT_URI, null,
                                ContactsContract.CommonDataKinds.Phone.CONTACT_ID + " = ?",
                                new String[]{id}, null);

                        phone = "";

                        while (pCur.moveToNext()) {
                            // Do something with phones

                            phone = pCur.getString(
                                    pCur.getColumnIndex(ContactsContract.CommonDataKinds.Phone.NUMBER)) + " " + phone;

                        }
                        pCur.close();


                    }

                }

                Cursor emailCur = cr.query(
                        ContactsContract.CommonDataKinds.Email.CONTENT_URI,
                        null,
                        ContactsContract.CommonDataKinds.Email.CONTACT_ID + " = ?",
                        new String[]{id}, null);

                email = "";

                while (emailCur.moveToNext()) {
                    // This would allow you get several email addresses
                    // if the email addresses were stored in an array
                    email = emailCur.getString(
                            emailCur.getColumnIndex(ContactsContract.CommonDataKinds.Email.DATA)) + " " + email;
                    String emailType = emailCur.getString(
                            emailCur.getColumnIndex(ContactsContract.CommonDataKinds.Email.TYPE));
                }
                emailCur.close();


                System.out.println("name: " + name + " phone: " + phone + " mail: " + email);

            }

            cur.close();
        }

    }
}



