package android.exemple.TD4_3;


import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.widget.Toast;

/**
 * IntentReceiver for NEW_OUTGOING_CALL that demonstrates catching an outgoing call
 * 
 *  
 * @author fcamps
 * 
 */
public class OutgoingCallReceiver extends BroadcastReceiver
{
	public static final String LOGTAG = "TelephonyExplorer";
	private static final String OUTGOING_CALL_ACTION = "android.intent.action.NEW_OUTGOING_CALL";
	private static final String INTENT_PHONE_NUMBER = "android.intent.extra.PHONE_NUMBER";
	
	@Override
	public void onReceive(final Context context, final Intent intent)
	{
		Log.v(LOGTAG, "OutgoingCallReceiver onReceive");

		if (intent.getAction().equals(OutgoingCallReceiver.OUTGOING_CALL_ACTION))
		{
			Log.v(LOGTAG, "OutgoingCallReceiver NEW_OUTGOING_CALL received");

			// n° de telephone
			String phoneNumber = intent.getExtras().getString(OutgoingCallReceiver.INTENT_PHONE_NUMBER);

			if ((phoneNumber != null))
			{
				Toast.makeText(context, "NEW_OUTGOING_CALL", Toast.LENGTH_LONG).show();
			}
		}
	} 

}