package android.exemple.TD4_4;

import java.util.List;

import android.exemple.R;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.ViewGroup;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

/**
 * 
 * @author fcamps
 *
 * 0 - Key in your keystore :
 * 
 * "keytool -v -list -keystore ~/.android/debug.keystore"
 *
 * 1- Key Generation, dans un shell : 
 * 
 * "keytool -list -alias androiddebugkey -keystore ~/.android/debug.keystore -storepass android -keypass android"
 * 
 * 2 - sign up :
 * 
 * http://code.google.com/android/maps-api-signup.html
 * 
 * 3 - copy your key in main.xml
 * 
 * 
 *
 */
public class MyMAP extends MapActivity 
{
	private MapView mapView;
	private MapController mapController;
	Double lat = 43.5634*1E6;
	Double lng = 1.4778*1E6;

	GeoPoint myPoint;

	private LocationManager locationManager;
	// http://developer.android.com/reference/android/location/LocationManager.html


	@Override
	public void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		this.setContentView(R.layout.main);

		// widget graphique pour les MAP
		this.mapView = (MapView) this.findViewById(R.id.mapView);

		// I am Here
		myPoint = new GeoPoint((int) (lat * 1000000), (int) (lng * 1000000));

		// information de zoom
		ViewGroup zoom = (ViewGroup) this.findViewById(R.id.zoom);

		mapView.setBuiltInZoomControls(true);

		// Point "i am here" / overlay
		MyLocationOverlay myLocationOverlay = new MyLocationOverlay();
		List<Overlay> list = mapView.getOverlays();
		list.add(myLocationOverlay);


		// affichage en mode satellite
		mapView.setSatellite(false); //mode carte
		mapView.setSatellite(false); //mode satelitte

		// controller de la map
		this.mapController = this.mapView.getController();

		// zoom sur la carte
		this.mapController.setZoom(16);  // Zoom 1 is world view


		//positionnement sur la carte
		this.gotoMyHome();

		// location change
		locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
		locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, new GeoUpdateHandler());
	}

	/**
	 * 
	 */
	private void gotoMyHome()
	{
		this.mapController.setCenter(new GeoPoint(lat.intValue(),lng.intValue()));
	}

	@Override
	protected boolean isRouteDisplayed()
	{
		return false;
	}


	/**
	 * 
	 * @author fcamps
	 *
	 * Systeme de localisation
	 * 
	 * 
	 */
	public class GeoUpdateHandler implements LocationListener
	{

		@Override
		public void onLocationChanged(Location location) 
		{
			int lat = (int) (location.getLatitude() * 1E6);
			int lng = (int) (location.getLongitude() * 1E6);
			myPoint = new GeoPoint(lat, lng);
			
			// replacement sur la carte
			mapController.animateTo(myPoint);

			Toast.makeText(getApplicationContext(), "LAT: " + lat/1E6 +  " LONG: " + lng/1E6 , Toast.LENGTH_SHORT).show();
		}

		@Override
		public void onProviderDisabled(String provider) 
		{
			Toast.makeText(getApplicationContext(), "Disabled provider " + provider, Toast.LENGTH_SHORT).show();
		}

		@Override
		public void onProviderEnabled(String provider) 
		{
			Toast.makeText(getApplicationContext(), "Enabled new provider " + provider, Toast.LENGTH_SHORT).show();
		}

		@Override
		public void onStatusChanged(String provider, int status, Bundle extras) 
		{
		}
	}



	/**
	 * 
	 * @author fcamps
	 *
	 * Affichage des points sur la carte
	 *
	 */
	class MyLocationOverlay extends com.google.android.maps.Overlay 
	{
		@Override
		public boolean onTap(GeoPoint p, MapView    mapView)  {

			return false;
		}

		@Override
		public boolean draw(Canvas canvas, MapView mapView, boolean shadow, long when)
		{

			super.draw(canvas, mapView, shadow);

			Paint paint = new Paint();
			// Converts lat/lng-Point to OUR coordinates on the screen.
			Point myScreenCoords = new Point();

			mapView.getProjection().toPixels(myPoint, myScreenCoords);
			paint.setStrokeWidth(1);
			paint.setARGB(255, 255, 255, 255);
			paint.setStyle(Paint.Style.STROKE);

			paint.setTextSize(20);
			paint.setColor(Color.RED);
			paint.setStrokeWidth(2);


			canvas.drawText("Here I am...", myScreenCoords.x-10,myScreenCoords.y-48, paint);
			return true;
		} 
	} 


}